/*
 * MosP - Mind Open Source Project         http://www.mosp.jp/
 * Copyright (C) 1987-2009 MIND Co., Ltd.  http://www.e-mind.co.jp/
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
package jp.mosp.workflow.action;

import java.util.List;

import jp.mosp.common.CommonConst;
import jp.mosp.common.action.MosPWorkflowAction;
import jp.mosp.common.common.MospConst;
import jp.mosp.common.common.MospException;
import jp.mosp.common.common.MospUtility;


import jp.mosp.workflow.dto.AmRouteDto;
import jp.mosp.workflow.dto.AmUnitDto;
import jp.mosp.workflow.vo.ApprovalRouteCardVo;

public class ApprovalRouteCardAction extends MosPWorkflowAction {

	// コマンド
	private static final String CMD_ROUTE_CARD_SHOW   = "S2825";	// 表示(追加)
	private static final String CMD_ROUTE_CARD_SELECT = "S2826";	// 表示(選択)
	private static final String CMD_ROUTE_CARD_INSERT = "S2827";	// 登録
	private static final String CMD_ROUTE_CARD_UPDATE = "S2828";	// 更新

	/**
	 * コンストラクタ
	 */
	public ApprovalRouteCardAction() {
		super();
	}

	/**
	 * アクション
	 */
	public void action() throws Exception {
		// DBコネクション取得
		getConnection();
		// SYSTEM権限確認
		confirmSystemAuth();
		// VOの取得及び設定
		ApprovalRouteCardVo vo = new ApprovalRouteCardVo();
		vo.initVo(cfg, msg, cmd, aspUser, user);
		vo.setParams(request);
		// VO及びフォワード先URLの設定
		setVo(vo);
		setUrl(vo.getRetUrl());
		// DTOの取得
		AmRouteDto dto;
		Object obj = session.getAttribute(MospConst.ATT_DTO);
		dto = obj instanceof AmRouteDto ? (AmRouteDto)obj : null;
		// プルダウンのセット
		setPulldownList(vo);
		// コマンド毎の処理
		if (cmd.equals(CMD_ROUTE_CARD_SHOW)) {
			vo.setDefaultValues();
			// モード設定
			setMode(vo);
		} else if (cmd.equals(CMD_ROUTE_CARD_SELECT)) {
			// 表示(キーで情報を検索)
			// データの取得
			dto = routeDao().findForKey(key1);
			chkExist(dto);
			// VOに情報をセット
			vo.setFields(dto);
			vo.setMode(ApprovalRouteCardVo.MODE_UPDATE);
			// セッションにDTOをセット
			session.setAttribute(MospConst.ATT_DTO, dto);
		} else if (cmd.equals(CMD_ROUTE_CARD_INSERT)) {
			// 新規登録
			dto = insert(vo);
			// セッションにDTOをセット
			session.setAttribute(MospConst.ATT_DTO, dto);
		} else if (cmd.equals(CMD_ROUTE_CARD_UPDATE)) {
			// 更新
			dto = update(vo, dto);
			// セッションにDTOをセット
			session.setAttribute(MospConst.ATT_DTO, dto);
		} else {
			throw new MospException(MospConst.EX_CMD_INVALID);
		}
	}

	/**
	 * プルダウンの設定
	 * @param vo
	 * @throws Exception
	 */
	private void setPulldownList(ApprovalRouteCardVo vo) throws Exception {
		// DBコネクションの取得
		if (conn == null) {
			getConnection();
		}
		// 承認ユニットコード一覧
		vo.aryPltUnit = getUnitArrayAvailable();
	}

	/**
	 * データ挿入
	 * @param vo 対象VO
	 * @return データ挿入対象DTO
	 * @throws Exception
	 */
	private AmRouteDto insert(ApprovalRouteCardVo vo) throws Exception {
		// パラメータの妥当性確認
		vo.validate();
		// 存在チェック
		chkDuplicate(routeDao().findForKey(vo.getTxtRouteCode()), vo);
		// DTOの準備
		AmRouteDto dto = new AmRouteDto();
		vo.setPltDelete(String.valueOf(MospConst.DELETE_FLAG_OFF));
		vo.setDtoFields(dto);
		// データの挿入
		routeDao().insert(dto);
		// DTOの再取得
		dto = routeDao().findForKey(dto.getRtCode());
		// コミット
		commit();
		// モード設定
		vo.setMode(ApprovalRouteCardVo.MODE_UPDATE);
		// メッセージ設定
		vo.setMessage(MospUtility.getMessage(msg, MospConst.MSG_INSERT, ""));
		return dto;
	}

	/**
	 * データ更新
	 * @param vo 対象VO
	 * @param dto 対象DTO
	 * @return データ挿入対象DTO
	 * @throws Exception
	 */
	private AmRouteDto update(ApprovalRouteCardVo vo, AmRouteDto dto) throws Exception {
		// コード取得
		vo.setTxtRouteCode(dto.getRtCode());
		// パラメータの妥当性確認
		vo.validate();
		// 排他確認
		chkExclusive(dto, routeDao().findForUpdate(vo.getTxtRouteCode()), vo);
		// DTOの準備
		vo.setDtoFields(dto);
		// データの更新
		routeDao().update(dto);
		// DTOの再取得
		AmRouteDto retDto = routeDao().findForKey(dto.getRtCode());
		chkUpdate(retDto);
		// コミット
		commit();
		// モード設定
		vo.setMode(ApprovalRouteCardVo.MODE_UPDATE);
		// メッセージ設定
		vo.setMessage(MospUtility.getMessage(msg, MospConst.MSG_UPDATE, ""));
		return retDto;
	}

	/**
	 * 承認ユニットコード取得（AM_UNIT）
	 * @return 利用可能な承認ユニットコードリスト
	 * @throws Exception
	 */
	private String[][] getUnitArrayAvailable() throws Exception {
		// 情報の取得
		String targetDate = util.convDateFormattedByHyphen(util.getSystemDate());
		List<AmUnitDto> listUnit = unitDao().findForSelectableUnitArray(targetDate);
		// 配列の作成
		String[][] aryUnit = new String[listUnit.size()][3];
		for (int i = 0; i < listUnit.size(); i++) {
			aryUnit[i][0] = listUnit.get(i).getUnitCode();
			StringBuffer sb = new StringBuffer();
			sb.append(getKName(listUnit.get(i).getMain()));
			sb.append(CommonConst.STR_2BYTE_SLASH_SEPARATOR);
			sb.append(getKName(listUnit.get(i).getAgent()));
			sb.append(CommonConst.NAM_COMMON_HALF_KANA_SPACE);
			sb.append(util.convHyphenDateToJPShortDate(listUnit.get(i).getStartDate()));
			sb.append(CommonConst.STR_TERM);
			aryUnit[i][1] = sb.toString();
		}
		return aryUnit;
	}

	/**
	 * モード設定
	 * @param vo 対象VO
	 * @throws Exception
	 */
	private void setMode(ApprovalRouteCardVo vo) throws Exception {
		// モード設定
		if (vo.aryPltUnit.length == 0) {
			vo.setMode(ApprovalRouteCardVo.MODE_IMPOSSIBLE);
		} else {
			vo.setMode(ApprovalRouteCardVo.MODE_INSERT);
		}
	}

}
